#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "stadium"

const int MaxN = 2000;

int x [MaxN], y [MaxN], p [MaxN];
int m, n, res;

inline bool less (int k, int l)
{
 return ((x[k] - x[m]) * (y[l] - y[m]) > (x[l] - x[m]) * (y[k] - y[m]));
}

inline bool equ (int k, int l)
{
 return ((x[k] - x[m]) * (y[l] - y[m]) == (x[l] - x[m]) * (y[k] - y[m]));
}

void qsort (int l, int r)
{
 int i, j, x, t;
 while (r - l > 1)
 {
  x = p[(l + r) >> 1];
  i = l, j = r;
  while (i < j)
  {
   while (less (p[i], x)) i++;
   while (less (x, p[j])) j--;
   if (i >= j) break;
   t = p[i]; p[i] = p[j]; p[j] = t;
   i++, j--;
  }
  if (i - l < r - j) qsort (l, j), l = i;
                else qsort (i, r), r = j;
 }
 if (r > l)
  if (less (p[r], p[l]))
  {
   t = p[l]; p[l] = p[r]; p[r] = t;
  }
}

int main (void)
{
 int i, j, k;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  for (i = 0; i < n; i++)
   scanf (" %d %d", &x[i], &y[i]);
  for (i = 0; i < n - 1; i++)
   for (j = i + 1; j < n; j++)
    if (x[j] < x[i] || x[j] == x[i] && y[j] < y[i])
    {
     k = x[i]; x[i] = x[j]; x[j] = k;
     k = y[i]; y[i] = y[j]; y[j] = k;
    }
  res = 0;
  for (m = 0; m < n; m++)
  {
   for (i = m + 1; i < n; i++) p[i] = i;
   res += ((n - m - 1) * (n - m - 2)) >> 1;
   qsort (m + 1, n - 1);
   k = 1;
   for (i = m + 2; i < n; i++)
    if (equ (p[i], p[i - 1])) k++;
    else {res -= (k * (k - 1)) >> 1; k = 1;}
   res -= (k * (k - 1)) >> 1;
  }
  printf ("%d\n", res);
 }
 return 0;
}
