#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "puzzle"

const int MaxN = 3;

bool b [MaxN] [MaxN];
int res;

inline void check (int x1, int y1, int x2, int y2, int x3, int y3,
 int x, int y, int cur);
void recur (int x, int y, int cur);

inline void check (int x1, int y1, int x2, int y2, int x3, int y3,
 int x, int y, int cur)
{
 if (!b[x1][y1] && !b[x2][y2] && !b[x3][y3])
 {
  b[x1][y1] = b[x2][y2] = b[x3][y3] = true;
  recur (x + 1, y, cur + 1);
  b[x1][y1] = b[x2][y2] = b[x3][y3] = false;
 }
}

void recur (int x, int y, int cur)
{
 if (res < cur)
  res = cur;
 if (y == 2) return;
 if (x == 2) {recur (0, y + 1, cur); return;}
 check (x + 0, y + 0, x + 0, y + 1, x + 1, y + 0, x, y, cur);
 check (x + 0, y + 1, x + 0, y + 0, x + 1, y + 1, x, y, cur);
 check (x + 1, y + 1, x + 1, y + 0, x + 0, y + 1, x, y, cur);
 check (x + 1, y + 0, x + 1, y + 1, x + 0, y + 0, x, y, cur);
 recur (x + 1, y, cur);
}

int main (void)
{
 char a [MaxN] [MaxN + 1];
 int i, j;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %s %s %s", a[0], a[1], a[2]) != EOF)
 {
  for (i = 0; i < MaxN; i++)
   assert (int (strlen (a[i])) == MaxN);
  for (i = 0; i < MaxN; i++)
   for (j = 0; j < MaxN; j++)
    assert (a[i][j] == 'X' || a[i][j] == '.');
  for (i = 0; i < MaxN; i++)
   for (j = 0; j < MaxN; j++)
    b[i][j] = (a[i][j] == 'X');
  res = -1;
  recur (0, 0, 0);
  printf ("%d\n", res);
 }
 return 0;
}
